/*******************************************************
*   Zodius©
*
*   Test hook for Zodius Lib
*
*   @author  YNOP (ynop@acm.org) 
*   @vertion test
*   @date    April 30 2001
*******************************************************/
#include <InterfaceKit.h>

#include "ZView.h"

#include "ZRenderer.h"
#include "ZColor.h"
#include "ZMatrix.h"

/*******************************************************
*
*******************************************************/
ZView::ZView(BRect frame):BView(frame, "", B_FOLLOW_ALL_SIDES, B_WILL_DRAW){
   SetViewColor(B_TRANSPARENT_32_BIT); // Let us control view rendering
   
   // Off screen bitmap to let Zodius render too.
   // Then we can splash it on the screen whenever we 
   // feel like it .. or don't
   OffScreen = new BBitmap(BRect(0,0,299,199),B_RGB32);
   
   // This acutally creates the wonderfull little vector
   // object. Paths are pritty easy.. move here .. move
   // there .. move somewhere .. end.
   ZPath path;
   path.AddMoveTo(ZPoint(10,10));
   path.AddLineTo(ZPoint(110,10));
   path.AddLineTo(ZPoint(110,110));
   path.AddLineTo(ZPoint( 10,110));
   path.AddClose();
   
   // Just to make things exciting we add a spiffy
   // Gradient in here. Lively uh?
   ZLinearGradientStencil stencil;
   stencil.SetColor(ZColor(0xFF,0xFF,0xFF,0x00),0,0.);
   stencil.SetColor(ZColor(0xFF,0xFF,0x00,0x00),1,.5);
   stencil.SetColor(ZColor(0xFF,0xFF,0x00,0xFF),2,1.);
   
   // The ZRenderer - all praize him, all on your knees now
   ZRenderer renderer;
   // Set the buffer to our bitmap, luckly BBitmap bits are 
   // aranged in such a way the it happends to work.  I would
   // mabey suggest a few better ways .. but this IS just a 
   // quick hack right?
   renderer.SetBuffer((uint32 *)OffScreen->Bits(),300,200,300);
   // Prepare the buffer - yes captan.
   renderer.ClearBuffer();
   // And - fire .. I mean render
   renderer.DrawPath(path,stencil);
   // Oh and if we didn't render some place .. just fill it
   renderer.FinalizeBuffer(ZColor(0xFF,0xAA,0xCC,0xAA));
   
}

/*******************************************************
*
*******************************************************/
ZView::~ZView(){
   delete OffScreen;
}

/*******************************************************
*
*******************************************************/
void ZView::Draw(BRect){
   // Just splash the off screen on screen.
   // it should be pritty.
   DrawBitmap(OffScreen);
}

/*******************************************************
*
*******************************************************/
void ZView::MessageReceived(BMessage *msg){
   switch(msg->what){
   default:
      BView::MessageReceived(msg);
   }
}












