/*******************************************************
*   Zodius©
*
*   Test hook for Zodius Lib
*
*   @author  YNOP (ynop@acm.org) 
*   @vertion test
*   @date    April 30 2001
*******************************************************/
#include <InterfaceKit.h>

#include <stdio.h>
#include <string.h> // for memset

#include "ZView.h"

// Stuff for actually useing Zodius
#include "ZRenderer.h"
#include "ZColor.h"
#include "ZMatrix.h"

/*******************************************************
*
*******************************************************/
ZView::ZView(BRect frame):BView(frame, "", B_FOLLOW_ALL_SIDES, B_WILL_DRAW){
   SetViewColor(B_TRANSPARENT_32_BIT); // Let us control view rendering
   
   // Off screen bitmap to let Zodius render too.
   // Then we can splash it on the screen whenever we 
   // feel like it .. or don't
   BRect r = frame;
   r.OffsetTo(0,0);
   OffScreen = new BBitmap(r,B_RGB32);
   
   // All the folowning sets up the path sturcutre from 
   // a spiffy little file. It does work pritty nice I must
   // say.
   float32 rad=0;
   sint32 cur=-1,cnt=0;
   ZColorStencil *stncs[64];
   ZPath *paths[64][64];
   memset(stncs,0,sizeof(stncs));
   memset(paths,0,sizeof(paths));
   
   FILE *fp = fopen("lion.txt","r");
   if(fp){
      char line[1024];
      for(;!feof(fp);){
         fgets(line,1024,fp);
         if(line[0]!='M'){
            cur++;
            cnt=0;
            uint32 color = 0;
            sscanf(line,"%x",&color);
            color|=0xFF000000;
            stncs[cur] = new ZColorStencil(color);
         }else{
            paths[cur][cnt] = new ZPath();
            ZPath path;
            sint32 x,y;
            char *scan = line;
            for(;sscanf(scan+1," %d,%d ",&x,&y);){
               if(*scan=='M'){
                  paths[cur][cnt]->AddMoveTo(ZPoint(x,y)-ZPoint(120,180));
               }else{
                  paths[cur][cnt]->AddLineTo(ZPoint(x,y)-ZPoint(120,180));
               }
               if(*scan == 0){ break; }
               for(scan++;*scan!='L';scan++){
                  if(*scan == 0){ break; }
               }
            }
            paths[cur][cnt]->AddClose();
            cnt++;
         }
      }
      fclose(fp);
   }else{
      // Hmm can't open the file. This is probably becase you 
      // didn't run this program from the Terminal. You see, 
      // BeOS has this think about relitive paths and such
      // when launched from Tracker... odd but true.
      // So, Run me from terminal!
      (new BAlert(NULL,"WARNING - programer lazzyness encountered, Please run this App from the Terminal","Ahh!"))->Go();
      exit(1);
   }
   
   // The ZRenderer - all praize him, all on your knees now
   ZRenderer renderer;
   // Set the buffer to our bitmap, luckly BBitmap bits are 
   // aranged in such a way the it happends to work.  I would
   // mabey suggest a few better ways .. but this IS just a 
   // quick hack right? 
   // We also use r becase I got tired of changing the size and 
   // haveing to come down here and ajust it again.
   //renderer.SetBuffer((uint32 *)OffScreen->Bits(),500,500,500);
   renderer.SetBuffer((uint32 *)OffScreen->Bits(),r.Height()+1,r.Width()+1,r.Height()+1);
   
   // Prepare the buffer - yes captan.
   renderer.ClearBuffer();
   
   rad+=.05; // this can be fun to play with .. and impressive.
   
   // Move the image around a little just for fun and to
   // make it look kewl on the screen.
   ZMatrix matrix;
   matrix.SetRotation(rad);
   //matrix.SetTranslation(ZPoint(250,250));
   matrix.SetTranslation(ZPoint((r.Height()+1)/2,(r.Width()+1)/2));
   
   for(sint32 c=cur;c>=0;c--){
      for(sint32 i=cnt-1;i>=0;i--){
         if(paths[c][i]){
            renderer.DrawPath(*paths[c][i],matrix,*stncs[c]);
         }
      }
   }
   
   // and fill the bg with white.
   renderer.FinalizeBuffer(0xFFFFFF); 
}

/*******************************************************
*
*******************************************************/
ZView::~ZView(){
   delete OffScreen;
}

/*******************************************************
*
*******************************************************/
void ZView::Draw(BRect){
   // Just splash the off screen on screen.
   // it should be pritty.
   DrawBitmap(OffScreen);
}

/*******************************************************
*
*******************************************************/
void ZView::MessageReceived(BMessage *msg){
   switch(msg->what){
   default:
      BView::MessageReceived(msg);
   }
}












