/*
	Copyright (c) 2000, Tinic Uro <tinic@tinic.net> 
	All rights reserved. Please read the LICENSE file 
	which is included in this distribution for details.
*/
#include "ZDash.h"

ZDash::ZDash()
{	
	for(sint32 c=0;c<ZDASHSLOTS;c++)
		lengths[c] = -1;
}

ZDash::ZDash(const ZDash &from)
{
	operator=(from);
}

/** Set length of a segment of the dash.
	The length use absolute coordiantes. 
	Even entries will be active parts, uneven
	non active.
*/
void ZDash::SetLength(float32 length, sint32 slot)
{
	if(slot>=0 && slot < ZDASHSLOTS) {
		lengths[slot] = length;
	}
}

/** Return the length of certain segments of the dash.
*/
const float32 ZDash::Length(sint32 slot) const
{
	if(slot>=0 && slot < ZDASHSLOTS) {
		return lengths[slot];
	}
	return 0;
}

ZDash &ZDash::operator=(const ZDash &from)
{
	for(sint32 c=0;c<ZDASHSLOTS;c++)
		lengths[c] = from.lengths[c];
	return *this;
}
