/*
	Copyright (c) 2000, Tinic Uro <tinic@tinic.net> 
	All rights reserved. Please read the LICENSE file 
	which is included in this distribution for details.
*/
#ifndef _ZDASHER_H_
#define _ZDASHER_H_

#include "ZSketcher.h"
#include "ZDash.h"

/// Computes dashes for paths
class ZDasher : public ZSketcher
{
	public:
						 ZDasher();
		virtual			~ZDasher() {};

				ZPath	 ComputeDash(const ZPath &from, const ZDash &dash);

				void	 SetOffset(float32 off) { offset = off;}
		const	float32	 Offset() const { return offset; }

	protected:

		virtual	void	 NewSegment(ZPoint a, ZPoint b);

		virtual	void	 MoveTo(ZPoint point);
		virtual	void	 Close();
		virtual	void	 End();

	private:

				ZDash	 dash;
				ZPath	 outshape;
				ZPath	 outpath;
				float32	 offset;
				float32	 curlen;
				sint32	 curslot;
};

#endif