/*
	Copyright (c) 2000, Tinic Uro <tinic@tinic.net> 
	All rights reserved. Please read the LICENSE file 
	which is included in this distribution for details.
*/
#ifndef _ZGRADIENT_H_
#define _ZGRADIENT_H_
#include "ZSystem.h"
#include "ZConfig.h"

/// Implements a color gradient
class ZGradient
{
	public: 

		enum
		{
			MODE_PAD,
			MODE_SPREAD,
			MODE_REPEAT
		};

					 ZGradient();
	virtual			~ZGradient() {}

			void	 SetColor(uint32 color, sint32 slot, float32 position);
			uint32	 GetColor(sint32 pos) const;
						/** Set mapping mode for this gradient.
							Can be either MODE_PAD, MODE_SPREAD or MODE_REPEAT.
						*/
			void	 SetMode(sint32 mode = MODE_PAD) { mod = mode; };

	private:

			void	Update();

			sint32	mod;
			uint32	pre[(1<<ZGRADIENTBUFFERBITS)];
			uint32	col[ZGRADIENTSLOTS];
			float32	pos[ZGRADIENTSLOTS];
};

#endif