/*
	Copyright (c) 2000, Tinic Uro <tinic@tinic.net> 
	All rights reserved. Please read the LICENSE file 
	which is included in this distribution for details.
*/
#ifndef _ZLINE_H_
#define _ZLINE_H_

#include "ZMatrix.h"

/// Represents a line in 2D space
class ZLine
{
	public:
	
			ZPoint	 P0;
			ZPoint	 P1;
					
					 ZLine();
					 ZLine(float32 p0x, float32 p0y, float32 p1x, float32 p1y);
					 ZLine(ZPoint p0, ZPoint p1);

		virtual		~ZLine();
		
		void		 Set(ZPoint p0, ZPoint p1);
		bool		 Intersects(const ZLine &from) const;
		ZPoint		 Intersection(const ZLine &from) const;
		float32		 Orientation(const ZPoint &from) const;
		ZPoint		 Center() const;
		float32		 Length() const;
		ZLine		 Head(float32 length) const;
		ZLine		 Tail(float32 length) const;
		ZPoint		 Split(float32 where);

};

#endif