/*
	Copyright (c) 2000, Tinic Uro <tinic@tinic.net> 
	All rights reserved. Please read the LICENSE file 
	which is included in this distribution for details.
*/
#ifndef _ZOUTLINER_H_
#define _ZOUTLINER_H_
#include "ZSketcher.h"
#include "ZLine.h"

/// Computes outlines of a path
class ZOutliner : public ZSketcher
{
	public:
	
		enum
		{
			JOINT_NONE,
			JOINT_BEVEL,
			JOINT_MITER,
			JOINT_ROUND
		};
		
		enum
		{
			CAPS_NONE,
			CAPS_BUTT,
			CAPS_ROUND,
			CAPS_ARROW
		};
	
						 ZOutliner();
		virtual			~ZOutliner();
		
				ZPath	 ComputeOutline(const ZPath &from);

							/// Set width of outline to be computed.
				void	 SetWidth(float32 width) { rad = width/2; }
							/// Set joint type. Can be JOINT_NONE, JOINT_BEVEL, JOINT_MITER, JOINT_ROUND
				void	 SetJointType(sint32 type) { joint = type; }
							/// Set cap type. Can be CAPS_NONE, CAPS_BUTT, CAPS_ROUND, CAPS_ARROW
				void	 SetCapType(sint32 type) { cap = type; }

	protected:

		virtual	void	 NewSegment(ZPoint a, ZPoint b);

		virtual	void	 Start();
		virtual	void	 MoveTo(ZPoint point);
		virtual	void	 LineTo(ZPoint point);
		virtual	void	 CurveTo(ZPoint control, ZPoint point);
		virtual	void	 CurveTo(ZPoint control1, ZPoint control2, ZPoint point);
		virtual	void	 ArcTo(ZPoint radius, ZPoint point, float32 rotation = 0, sint32 sweep_arc = 1);
		virtual	void	 Close();
		virtual	void	 End();


	private:
				sint32	 joint;
				sint32 	 cap;
				float32	 rad;
				
				ZPath	 outpath;
				ZPath	 innshap;
				ZPath	 outshap;

				ZLine 	 strhead;
				ZLine 	 strtail;
				ZLine 	 oldhead;
				ZLine 	 oldtail;

				ZPoint	 savemovetop0;
				ZPoint	 savemovetop1;

				bool	 firstmoveto;
				bool	 newsegment;
};

#endif