/*
	Copyright (c) 2000, Tinic Uro <tinic@tinic.net> 
	All rights reserved. Please read the LICENSE file 
	which is included in this distribution for details.
*/
#ifndef _Z_RENDERER_H_
#define _Z_RENDERER_H_
#include "ZSketcher.h"
#include "ZStencil.h"

/// Draws paths to frame buffers
class ZRenderer : public ZSketcher
{
	public:

		enum
		{
			MODE_XOR,
			MODE_ZERO
		};

						 ZRenderer();
		virtual			~ZRenderer();

				void	 DrawPath(const ZPath &path, ZStencil &stencil, sint32 mode = MODE_XOR);
				void	 DrawPath(const ZPath &path, const ZMatrix &matrix, ZStencil &stencil, sint32 mode = MODE_XOR);

				void	 SetBuffer(uint32 *bits, uint32 wdth, uint32 hght, uint32 pprw);
				void	 ClearBuffer();
				void	 FinalizeBuffer(uint32 color);

	protected:

		virtual	void	 NewSegment(ZPoint P0, ZPoint P1);

	private:

		inline	void	 DrawBuffer();
		inline	void	 DoScanline(float32 Sx, float32 Sy, float32 Ex, float32 Ey);
		inline	void	 MergePixels(sint32 x, sint32 y, sint32 count, uint08 opacity);

		const ZMatrix	*_mtrx;
		ZStencil		*_stnc;
		uint32			*_scan;
		uint32			*_scanbuf;
		uint32			*_scanbuf_tmp;
		uint32			*_bits;
		uint32			 _pprw;
		sint32			 _wdth;
		sint32			 _hght;
		sint32			 _opsx;
		sint32			 _opsy;
		sint32			 _mode;
		float32			 _xmin;
		float32			 _xmax;
		float32			 _ymin;
		float32			 _ymax;
		bool			 _mono;
};

#endif
