/*
	Copyright (c) 2000, Tinic Uro <tinic@tinic.net> 
	All rights reserved. Please read the LICENSE file 
	which is included in this distribution for details.
*/
#ifndef _ZSKETCHER_H_
#define _ZSKETCHER_H_
#include "ZConfig.h"
#include "ZPath.h"

/// splits curves&arc into simple lines
class ZSketcher : public ZPath::Iterator
{
	public:
						  ZSketcher():_shape_closed(true) { SetSamplingSteps(); }
		virtual			 ~ZSketcher() {}

				void	  SetSamplingSteps(sint32 steps = 32);

	protected:

		virtual	void	  NewSegment(ZPoint a, ZPoint b);

		virtual	void	  Start();
		virtual	void	  MoveTo(ZPoint point);
		virtual	void	  LineTo(ZPoint point);
		virtual	void	  CurveTo(ZPoint control, ZPoint point);
		virtual	void	  CurveTo(ZPoint control1, ZPoint control2, ZPoint point);
		virtual	void	  ArcTo(ZPoint radius, ZPoint point, float32 rotation = 0, sint32 large_arc = 1, sint32 sweep_arc = 1);
		virtual	void	  Close();
		virtual	void	  End();

		ZPoint			  ShapeCurrentPoint() { return _curr_point; }
		ZPoint			  ShapeStartPoint() { return _strt_point; }
		bool			  ShapeClosed() { return _shape_closed; }
		
	private:

		sint32			 _samp_steps;
		float32			 _step_pow_1;
		float32			 _step_pow_2;
		float32			 _step_pow_3;
		ZPoint			 _strt_point;
		ZPoint			 _curr_point;
		bool			 _shape_closed;
};

#endif