/*
	Copyright (c) 2000, Tinic Uro <tinic@tinic.net> 
	All rights reserved. Please read the LICENSE file 
	which is included in this distribution for details.
*/
#ifndef _ZSYSTEM_H_
#define _ZSYSTEM_H_

#if WIN32

typedef unsigned __int64 	uint64;
typedef signed __int64		sint64;
typedef unsigned long		uint32;
typedef signed long			sint32;
typedef unsigned short		uint16;
typedef signed short		sint16;
typedef unsigned char		uint08;
typedef signed char			sint08;
typedef float				float32;
typedef	double				float64;

#else

typedef unsigned long long 	uint64;
typedef signed long long	sint64;
typedef unsigned long		uint32;
typedef signed long			sint32;
typedef unsigned short		uint16;
typedef signed short		sint16;
typedef unsigned char		uint08;
typedef signed char			sint08;
typedef float				float32;
typedef	double				float64;

#endif

#define ZPI					3.14159265358979323846f
#define ZMAXFLOAT32			3.40282347e+38f
#define ZMAXFLOAT64			1.7976931348623157e+308
#define ZMINFLOAT32			1.17549435e-38f
#define	ZMINFLOAT64			2.2250738585072014e-308

template <class T> inline T ZMAX(T a, T b) { return ((a>b)?(a):(b)); }
template <class T> inline T ZMIN(T a, T b) { return ((a<b)?(a):(b)); }

#endif
