/*
	Copyright (c) 2000, Tinic Uro <tinic@tinic.net> 
	All rights reserved. Please read the LICENSE file 
	which included in this distribution for details.
*/
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/mman.h>
#include "ZRenderer.h"
#include "ZOutliner.h"
#include "ZColor.h"

unsigned char buffer[800*600*3];
unsigned char screen[800*600*4]; 

int screen_fd=0;

void open_screen()
{
	screen_fd=open("/dev/fb0",O_WRONLY);
}

void close_screen()
{
	close(screen_fd);
}

void update(void)
{
	unsigned char *p0=screen;
	unsigned char *p1=buffer;

	for(int dd=0;dd<(800*600);dd++)
	{
		p1[0]=p0[0];
		p1[1]=p0[1];
		p1[2]=p0[2];
		p1+=3;
		p0+=4;
	}

	lseek(screen_fd,0,SEEK_SET);
	write(screen_fd,buffer,sizeof(buffer));
}

int main()
{
	ZRenderer renderer;
	ZOutliner outliner;
	
	open_screen();

	renderer.SetBuffer((uint32 *)screen,(uint32)800,(uint32)600,(uint32)800);
	
	ZPath path;
	path.AddMoveTo(ZPoint(-200,-200));
	path.AddLineTo(ZPoint( 200,-200));
	path.AddLineTo(ZPoint( 200, 200));
	path.AddLineTo(ZPoint(-200, 200));
	path.AddClose();
//	path.AddMoveTo(ZPoint(-200,-200));
//	path.AddCurveTo(ZPoint(200,-200),ZPoint(200,200));
//	path.AddCurveTo(ZPoint(-200,200),ZPoint(200,-200));
//	path.AddCurveTo(ZPoint(-300,200),ZPoint(-200,-200));	
//	path.AddClose();
//	path.AddMoveTo(ZPoint(-200,-200));
//	path.AddLineTo(ZPoint( 200,-200));
//	path.AddLineTo(ZPoint( 200, 200));
//	path.AddLineTo(ZPoint(-200, 200));
//	path.AddClose();
	

	ZColorStencil fill(0xFF7F7F7F);	
//	ZLinearGradientStencil fill;
//	fill.SetColor(ZColor::AlphaMultiply(0xFF000000),0,0);
//	fill.SetColor(ZColor::AlphaMultiply(0xFF0000FF),1,.5);
//	fill.SetColor(ZColor::AlphaMultiply(0xFF00FF00),2,1);
//	ZColorStencil stencil(ZColor::AlphaMultiply(0x7FFF0000));
//	ZLinearGradientStencil stencil;
	ZRadialGradientStencil stencil;
	stencil.SetColor(ZColor::AlphaMultiply(0xFFFFFFFF),0,0);
	stencil.SetColor(ZColor::AlphaMultiply(0xFF00FFFF),1,.5);
	stencil.SetColor(ZColor::AlphaMultiply(0xFF0000FF),2,1);
	ZMatrix matrix;

//	outliner.SetJointType(ZOutliner::JOINT_NONE);
	outliner.SetWidth(32);
//	for(float32 c=0;c<M_PI*2;c+=M_PI/4)
	{
		renderer.ClearBuffer();
//		matrix.SetRotation(c);
//		matrix.SetScaling(ZPoint(.3,.3));
		matrix.SetTranslation(ZPoint(400,300));
//		renderer.DrawPath(outliner.ComputeOutline(path),matrix,stencil,ZRenderer::MODE_ZERO);
//		renderer.DrawPath(outliner.ComputeOutline(outliner.ComputeOutline(path,32),8),matrix,stencil,ZRenderer::MODE_ZERO);
//		renderer.DrawPath(outliner.ComputeOutline(outliner.ComputeOutline(outliner.ComputeOutline(path,64),16),4),matrix,stencil,ZRenderer::MODE_ZERO);
		renderer.DrawPath(path,matrix,stencil,ZRenderer::MODE_ZERO);
//	}
 		renderer.FinalizeBuffer(0xFFFFFF);
		update();
	}
	

	close_screen();

/*	float32 rad=0;
	sint32 cur=-1,cnt=0;
	ZColorStencil *stncs[64];
	ZPath *paths[64][64];
	memset(stncs,0,sizeof(stncs));
	memset(paths,0,sizeof(paths));

	printf("Reading file...\n");

	{FILE *fp = fopen("lion.txt","r");
	if(fp)
	{
		char line[1024];
		for(;!feof(fp);)
		{
			fgets(line,1024,fp);
			if(line[0]!='M')
			{
				cur++;
				cnt=0;
				uint32 color = 0;
				sscanf(line,"%x",&color);
				color|=0xFF000000;
				stncs[cur] = new ZColorStencil(color);
			}
			else
			{
				paths[cur][cnt] = new ZPath();
				ZPath path;
				sint32 x,y;
				char *scan = line;
				for(;sscanf(scan+1," %d,%d ",&x,&y);)
				{
					if(*scan=='M')
					{
						paths[cur][cnt]->AddMoveTo(ZPoint(x,y)-ZPoint(120,180));
					}
					else
					{
						paths[cur][cnt]->AddLineTo(ZPoint(x,y)-ZPoint(120,180));
					}
					if(*scan == 0) break;
					for(scan++;*scan!='L';scan++) 
					{
						if(*scan == 0) break;
					}
				}
				paths[cur][cnt]->AddClose();
				cnt++;
			}
		}
		fclose(fp);
	}}
	
	ZMatrix matrix;

	printf("Starting drawing...\n");
	
	open_screen();

	for(;;)
	{
		renderer.SetBuffer((uint32 *)screen,(uint32)800,(uint32)600,(uint32)800);
		renderer.ClearBuffer();

		rad+=.05;

		matrix.SetRotation(rad);
		matrix.SetTranslation(ZPoint(400,300));
		{for(sint32 c=cur;c>=0;c--)
		{
			for(sint32 i=cnt-1;i>=0;i--)
			{
				if(paths[c][i])
				{
					renderer.DrawPath(*paths[c][i],matrix,*stncs[c]);
				}
			}
		}}
	 	renderer.FinalizeBuffer(0xFFFFFF);
		update();
	}
	
	close_screen();

*/
}